//  RTree version 1.4
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modifed version) source code is prohibited. You may only redistribute compiled versions.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//

package com.java4less.rmenu;


import com.java4less.rtree.*;
import java.awt.*;
import java.applet.*;
import java.util.*;

/**
 * <P>The RMenuApplet is a thin layer on the RMenu class that allows you to
use the RMenuas an applet in a web page. The parameters for the applet
are:</P>

<H2>Parameters of the applet&nbsp;</H2>

<P>Allmost all parameters are Strings or Integers, however the are some
special cases:</P>

<UL>
<LI>Colors: valid values are: RED,BLUE,GREEN,BLACK,GRAY,LIGHTGRAY,WHITE,DARKGRAY,YELLOW,ORANGE,CYAN
and MAGENTA. You can also use the numerical value of a color as parameter.</LI>

<LI>Fonts have the format&nbsp; &lt;font name&gt;|&lt;style&gt;|&lt;size&gt;.
Style can be PLAIN, ITALIC or BOLD. Example: &quot;Arial|BOLD|12&quot;</LI>
</UL>

<P>The parameters of the applet are:</P>

<UL>
<LI><B>TREE_ANIMATION_DELAY</B>: time in milliseconds between scenes of
the initial animation.</LI>

<LI><B>TREE_BACK_COLOR:</B> background color of the menu.</LI>

<LI><B>TREE_BACK_IMAGE:</B> background image for the menu.</LI>

<LI><B>TREE_BORDER</B>: type of border. Valir values are: NO,RAISED,LOWERED,LINE,LINE2,SHADOW
and DOUBLE.</LI>

<LI><B>TREE_BORDER_COLOR:</B> color of the border.</LI>

<LI><B>TREE_BOX_COLOR:</B> color of the box used to display the tips. The
default value is BLACK.</LI>

<LI><B>TREE_EXPAND_MODE.</B> Valid values are:<BR>
ON_CLICK: a node will be expanded only when the user clicks on it<BR>
ON_ENTER: a node will be automatically expanded when the cursor is on it.&nbsp;</LI>

<LI><B>TREE_INTERNAL_MARGIN: </B>space between the border of the menu and
the items.</LI>

<LI><B>TREE_ITEM_HEIGHT</B>. Height of the nodes of the menu. The default
value is 20 (in pixels).</LI>

<LI><B>TREE_ITEM_WIDTH</B>. Width of the nodes of the menu.The default
value is 100 (in pixels).</LI>

<LI><B>TREE_ITEMS_ALIGN: </B>how items are going to be aligned on a horizontal
menu. (LEFT, RIGHT or CENTER).</LI>

<LI><B>TREE_ITEMSX: </B>x coordinates of the items for a menu of type &quot;DEFINED&quot;.
The coordinates will be separed by | (e.g. &quot;10|30|10&quot;).</LI>

<LI><B>TREE_ITEMSY:</B> y coordinates of the items for a menu of type &quot;DEFINED&quot;.
The coordinates will be separed by | (e.g. &quot;10|30|10&quot;).</LI>

<LI><B>TREE_LOADING_FONT</B>: Font to be used for the text displayed when
the tree is loading a definition file or images.</LI>

<LI><B>TREE_LOADING_IMAGE</B>: Image to be displayed when the menu is loading
a definition file or images.</LI>

<LI><B>TREE_LOADING_TEXT</B>: This is the text to be displayed when the
menu is loading a definition file or images. The default value is &quot;Loading...&quot;;</LI>

<LI><B>TREE_LEFT_MARGIN</B>. In pixels.</LI>

<LI><B>TREE_LINE_TYPE</B>: This is the type of line used to link a node
and its children. Valid values as NORMAL, DASHED or DOTS.</LI>

<LI><B>TREE_MENU_TYPE: </B>Type of menu:&nbsp;VERTICAL, HORIZONTAL (see
TREE_ITEMS_ALIGN ) and DEFINED (see TREE_ITEMSX and TREE_ITEMSY).</LI>

<LI><B>TREE_OPEN_TEXT</B>: This is the text to be displayed when the tree
is opening a link after the user double-clicks a node. The default value
is &quot;Opening URL...&quot;;</LI>

<LI><B>TREE_PAGE_BACK_COLOR</B>: background color of the page where the
applet is.</LI>

<LI><B>TREE_SEPARATOR:</B> separator of items in a horizontal menu.</LI>

<LI><B>TREE_SUBMENU_ICON: </B>maged used to signal that there is a submenu.</LI>

<LI><B>TREE_TARGET</B>: target frame of the HTML page. Valid values are:
&quot;_self&quot;, &quot;_parent&quot;,&quot;_top&quot;, &quot;_blank&quot;
or &lt;frame name&gt;. This is the default used if it is not otherwise
specified at the node level.</LI>

<LI><B>TREE_TIP_BACK_COLOR:</B> background color of the tips. The default
value is YELLOW.</LI>

<LI><B>TREE_TIP_COLOR</B>: text color of the tips.</LI>

<LI><B>TREE_TIP_DELAY</B>: This is the number of milliseconds the tree
is going to wait before showing the tip of the current node.</LI>

<LI><B>TREE_TIP_FONT</B>: text font of the tips.</LI>

<LI><B>TREE_TOP_MARGIN.</B> In pixels.</LI>
</UL>

<P>The following parameters define default values for the nodes:</P>

<UL>
<LI><B>NODE_BACK_COLOR</B>: background color of the node.</LI>

<LI><B>NODE_BACK_IMAGE:</B> background image of the nodes.</LI>

<LI><B>NODE_BACK_SELECTED_COLOR:</B> background color when the node is
selected.</LI>

<LI><B>NODE_CENTER_TEXT: </B>center text of the nodes.</LI>

<LI><B>NODE_COLOR</B>: color of the texts.</LI>

<LI><B>NODE_EXPANDED_ICON</B>: icon when the node is expanded.</LI>

<LI><B>NODE_FONT</B>: font of the text..</LI>

<LI><B>NODE_RAISED:</B> if &quot;Y&quot; the node will displayed a &quot;raised&quot;
effect when it is selected.</LI>

<LI><B>NODE_SELECTED_COLOR</B>: color of the text when the node is selected.</LI>

<LI><B>NODE_SUBMENUCOLOR: </B>Color of the background of this node's submenu.</LI>

<LI><B>NODE_SUBMENU_INVERTED:</B> is this node'submenu to be inverted.
An inverted menu is display from bottom to top.&nbsp;Valid values are &quot;N&quot;
and &quot;Y&quot;.</LI>

<LI><B>NODE_SUBMENU_BORDER_COLOR: </B>Color of the border of this node's
submenu.</LI>

<LI><B>NODE_SUBMENU_BORDER:</B> type of border of this node's submenu.&nbsp;Valid
values are &quot;NO&quot;, &quot;LINE&quot; and &quot;RAISED&quot;.</LI>

<LI><B>NODE_SUBMENU_IMAGE:</B> background image of the submenu<B>.</B></LI>
</UL>

<P>The following parameters define the value for a given node. The * must
be substituted by the node's name. If the parameters are used in Javascript
or in a definition file the *_ should not be included:</P>

<UL>
<LI><B>*_BACK_IMAGE</B>: background image of the node.</LI>

<LI><B>*_CENTER_TEXT</B>: center text of the node.</LI>

<LI><B>*_BACK_COLOR:</B> background color of the node.</LI>

<LI><B>*_BACK_SELECTED_COLOR</B>: background color when the node is selected.</LI>

<LI><B>*_COLOR:</B> color of the texts.</LI>

<LI><B>*_DATA_FILE:</B> file where the definition of the children of this
node can be found.</LI>

<LI><B>*_EXPANDED: </B>Valid values are &quot;Y&quot; or &quot;N&quot;.</LI>

<LI><B>*_EXPANDED_ICON</B>: icon when the node is expanded.</LI>

<LI><B>*_ICON:</B> icon of the node.</LI>

<LI><B>*_FONT:</B> font of the text..</LI>

<LI><B>*_LINK</B>: URL to open when the user double-clicks the node.</LI>

<LI><B>*_RAISED:</B> if &quot;Y&quot; the node will displayed a &quot;raised&quot;
effect when it is selected.</LI>

<LI><B>*_SELECTED_COLOR</B>: color of the text when the node is selected.</LI>

<LI><B>*_SUBMENUCOLOR:</B> see NODE_SUBMENUCOLOR;</LI>

<LI><B>*_SUBMENU_INVERTED:</B> see NODE_SUBMENU_INVERTES;</LI>

<LI><B>*_SUBMENU_BORDER_COLOR:</B> see NODE_SUBMENU_BORDER_COLOR;</LI>

<LI><B>*_SUBMENU_BORDER:</B> see NODE_SUBMENU_BORDER;</LI>

<LI><B>*_SUBMENU_IMAGE:</B> see NODE_SUBMENU_IMAGE;</LI>

<LI><B>*_TARGET</B>: target frame of the HTML page. Valid values are: &quot;_self&quot;,
&quot;_parent&quot;,&quot;_top&quot;, &quot;_blank&quot; or &lt;frame name&gt;.</LI>

<LI><B>*_TEXT:</B> text for this node.</LI>

<LI><B>*_TIP</B>: tip for this node.</LI>
</UL>

<P>&nbsp;</P>

<P>The following parameters will allow you to execute JavaScript functions
when something happens:</P>

<UL>
<LI><B>TREE_ON_ENTER: </B>This function will be executed when the mouse
enters the menu. It has no parameters.</LI>

<LI><B>TREE_ON_EXIT:</B> This function will be executed when the mouse
exits the menu. It has no parameters.</LI>

<LI><B>TREE_ON_LOAD:</B> This function will be executed applet is loading
nodes and images.</LI>

<LI><B>TREE_ON_LOAD_END:</B> This function will be executed the applet
has finished loading nodes and images..</LI>

<LI><B>TREE_ON_SELECT</B>: This function will be executed when the mouse
is over a node. The function will receive as parameter, the node's name.</LI>

<LI><B>TREE_ON_EXPAND:</B> This function will be executed when the user
expands a node. The function will receive as parameter, the node's name.</LI>

<LI><B>TREE_ON_DBL_CLICK</B>: This function will be executed when the user
double-clicks a node. The function will receive as parameter, the node's
name.</LI>
</UL>

<P>See the file Example3.html to see an example of these parameters.&nbsp;</P>

<P>&nbsp;</P>

<H2>Loading from files<BR>
</H2>

<P><A NAME="methods"></A></P>

<P>The data for a node or menu can also be loaded from a text file instead
of using the parameters of the applet. The advantadge of this approach
is: </P>

<UL>
<LI>You can change the menu in you HTML page without modifing the HTML
file.</LI>

<LI>The menu's nodes will be loaded dynamically. Only when the node is
expanded its children will be created.</LI>

<LI>In the case of a big menu using parameters would result in a big HTML
file.</LI>
</UL>

<P>The structure of the file is very simple; <B>each file contains the
definition of the children of one node only</B>. Each line in the file
contains one command. The command can be: </P>

<UL>
<LI>CHILD=&lt;new node's name&gt; to create a new child</LI>

<LI>&lt;parameter's name&gt;=&lt;parameter's value&gt; to assign a vaue
to the child.</LI>
</UL>

<P>For example:</P>

<BLOCKQUOTE>
<P><I>CHILD=Index<BR>
ICON=car1.gif<BR>
SELECTED_ICON=car2.gif<BR>
DATA_FILE=file://www.myserver/IndexNodes.txt<BR>
TEXT=Index<BR>
CHILD=Features<BR>
</I>.<BR>
.<BR>
. </P>
</BLOCKQUOTE>

<P>&nbsp;This file creates a new node called &quot;Index&quot;. The following
4 lines contain some parameters for this node. This parameters have the
same name as those used in the applet parameters (without the *_). Note
that the children of the node &quot;index&quot; will be defined in the
file &quot;IndexNodes.txt&quot;.</P>

<H2>Javascript </H2>

<P>It is also possible to change teh appearance of the menu from Javascript
(See the file Example1.html to see an example of this). The following methods
can be accessed from javascript : </P>

<ul>
  <li><b>clearTree</b> </li>
  <li><b>getNodeProperty</b> </li>
  <li><b>setParam </b></li>
  <li><b>refreshTree</b> </li>


</ul>


 */
public class RMenuApplet extends Applet
{

	private final static int LEFT_BORDER=0;
    private final static int TOP_BORDER=2;
	private final static int BOTTOM_BORDER=3;
	private final static int RIGHT_BORDER=4;
	private boolean started=false;

	// tree
	public RMenu tree = new RMenu();
	// canvas used to draw the border
    borderCanvas appBorderLeft=new borderCanvas(LEFT_BORDER);
	borderCanvas appBorderRight=new borderCanvas(RIGHT_BORDER);
	borderCanvas appBorderTop=new borderCanvas(TOP_BORDER);
	borderCanvas appBorderBottom=new borderCanvas(BOTTOM_BORDER);

	// border types
    public static final int NO_BORDER=0;
	public static final int BORDER_LINE=1;
	public static final int BORDER_RAISED=2;
	public static final int BORDER_LOWERED=3;
	public static final int BORDER_DOUBLE=4;
	public static final int BORDER_SHADOW=5;
	public static final int BORDER_LINE2=6;

	// size of the border
	private int upperBorder=0;
    private int bottomBorder=0;
	private int leftBorder=0;
	private int rightBorder=0;

	// properties related with the border
	public int borderType=BORDER_LINE;
	public Color pageBackColor=java.awt.Color.white;
	public java.awt.Color borderColor=java.awt.Color.black;

	// FUNCTIONS FOR JAVA SCRIPT

	/**
         * <P>Sets a parameter for a node. This methods allows the configuration of
the applet from javascript. For example, in order to change the icon of
a node called &quot;node1&quot;:</P>

<P>javascript:document.tree.setParam('node1','ICON','newicon.gif');</P>

<P>&nbsp;In the example &quot;tree&quot; is the name of the applet.
         */
	public void setParam(String nodeName,String Param,String Value) {

	 RNode n=null;
	 if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	 tree.processParameter(n,Param.toUpperCase(),Value);

	}

/**
 * deletes the children of the node.
 */
	public void clearTree(String nodeName) {
	 RNode n=null;

	 if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	 if (n==null) n=tree.Root;

	 tree.clear(n);

	 // collapse and expand root to update nodes
	 tree.expandNode(tree.Root.Name,false);
	 tree.expandNode(tree.Root.Name,true);
	 tree.refresh();

	}

	/**
         * loads the children of the node <I>nodename</I> from the file <I>sFile</I>.

         */
	public void loadNode(String nodeName,String sFile) {

	 // detele before loading new data
	 clearTree(nodeName);

	 RNode n=null;
	 if (nodeName.length()>0) n=tree.findNode(tree.Root,nodeName);

	 if (n==null) n=tree.Root;

	 n.childrenDefinitionFile=sFile;
	 tree.createTreeFromFile(n,sFile);
	 // collapse and expand root to update nodes
	 tree.expandNode(tree.Root.Name,false);
	 tree.expandNode(tree.Root.Name,true);
	 tree.refresh();

	}

	/**
         * repaints the tree. The Javascript should call this after using other functions in other methods.
         */
	public void refreshTree() {
		tree.refresh();
	}

	// END OF FUNCTIONS FOR JAVA SCRIPT


	public void init() {

		  if (started) return;

		  // check if the protection key is valid
		  super.init();

		  // set the applet of the tree
		  tree.parentApplet=this;

		   // read parameters for the applet itself , border
	 	  String param;
		  param=getStringParam("TREE_PAGE_BACK_COLOR","WHITE");
		  if (param.length()>0) pageBackColor=tree.convertColor(param);
		  param=getStringParam("TREE_BORDER_COLOR","BLACK");
		  if (param.length()>0) borderColor=tree.convertColor(param);

		  // text and image to show while loading
		  param=getStringParam("TREE_LOADING_TEXT","");
		  if (param.length()>0) tree.loadingText=param;
		  param=getStringParam("TREE_LOADING_FONT","");
		  if (param.length()>0) tree.loadingFont=tree.convertFont(param);
		  param=getStringParam("TREE_LOADING_IMAGE","");
		  if (param.length()>0) tree.loadingImage=tree.loadImageUrl(param);

		   param=getStringParam("TREE_BORDER","");
		  if (param.length()>0) {
			 if (param.compareTo("NO")==0) borderType=NO_BORDER;
			 if (param.compareTo("RAISED")==0) borderType=BORDER_RAISED;
			 if (param.compareTo("LINE")==0) borderType=BORDER_LINE;
			 if (param.compareTo("LINE2")==0) borderType=BORDER_LINE2;
			 if (param.compareTo("LOWERED")==0) borderType=BORDER_LOWERED;
			 if (param.compareTo("SHADOW")==0) borderType=BORDER_SHADOW;
			 if (param.compareTo("DOUBLE")==0) borderType=BORDER_DOUBLE;
		  }



		  this.setLayout(null);

		  // size of the scroll area depends on the border's size
		  calculateBorderSize();

		  // for canvas bor the border
		  if (leftBorder>0) {
			  appBorderLeft.setBounds(0,upperBorder,leftBorder,this.getSize().height-bottomBorder-upperBorder);
			  this.add(appBorderLeft);
		  }
		  if (rightBorder>0) {
			  appBorderRight.setBounds(this.getSize().width-rightBorder,upperBorder,rightBorder,this.getSize().height-bottomBorder-upperBorder);
			  this.add(appBorderRight);
		  }
		  if (upperBorder>0) {
			  appBorderTop.setBounds(0,0,this.getSize().width,upperBorder);
			  this.add(appBorderTop);
		  }
		  if (bottomBorder>0) {
			  appBorderBottom.setBounds(0,this.getSize().height-bottomBorder,this.getSize().width,bottomBorder);
			  this.add(appBorderBottom);
		  }


		  setBorderBackground();

		  tree.setBounds(leftBorder,upperBorder,this.getSize().width-rightBorder-leftBorder,this.getSize().height-upperBorder-bottomBorder);
		  this.add(tree);

	}


	public void start() {
		 if (started) return;
		// start tree (this starts the initial animation)
		started=true;
		new Thread(tree).start();
	}


	protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);

    }


  //Get a parameter value
  private String getParameter(String key, String def) {
    if (getParameter(key) != null) return getParameter(key) ;
    else return def;
  }



  // the color of the canvas are used to simulate the border
  public void setBorderBackground() {

     if ((borderType==BORDER_LINE)|| (borderType==BORDER_LINE2)) {
		   appBorderLeft.setBackground(borderColor);
		   appBorderTop.setBackground(borderColor);
		   appBorderBottom.setBackground(borderColor);
		   appBorderRight.setBackground(borderColor);
	   }

	   if (borderType==BORDER_LOWERED)  {

		   appBorderLeft.setBackground(java.awt.Color.darkGray);
		   appBorderTop.setBackground(java.awt.Color.darkGray);
		   appBorderBottom.setBackground(java.awt.Color.white);
		   appBorderRight.setBackground(java.awt.Color.white);
	   }

	   if ((borderType==BORDER_RAISED) || (borderType==BORDER_DOUBLE)) {
		   appBorderBottom.setBackground(java.awt.Color.darkGray);
		   appBorderRight.setBackground(java.awt.Color.darkGray);
		   appBorderTop.setBackground(java.awt.Color.white);
		   appBorderLeft.setBackground(java.awt.Color.white);
	   }


	   if (borderType==BORDER_DOUBLE) {

		   appBorderBottom.setBackground(borderColor);
		   appBorderRight.setBackground(borderColor);
		   appBorderTop.setBackground(borderColor);
		   appBorderLeft.setBackground(borderColor);

		}
  }


	  // calculate size of the canvas used to simulate the border
	private void calculateBorderSize() {

	   if ((borderType==BORDER_LINE)|| (borderType==BORDER_LINE2)) {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
		   if (borderType==BORDER_LINE2) {
		     upperBorder=2;
		     leftBorder=2;
		     bottomBorder=2;
		     rightBorder=2;
		   }
	   }

	   if (borderType==BORDER_LOWERED)  {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
	   }

	   if ((borderType==BORDER_RAISED) || (borderType==BORDER_DOUBLE)) {
		   upperBorder=1;
		   leftBorder=1;
		   bottomBorder=1;
		   rightBorder=1;
	   }

	   if (borderType==BORDER_DOUBLE) {
		   upperBorder=4;
		   leftBorder=4;
		   bottomBorder=4;
		   rightBorder=4;
	   }

	    if (borderType==BORDER_SHADOW) {
		   upperBorder=0;
		   leftBorder=0;
		   bottomBorder=4;
		   rightBorder=4;
		}

	}


	// Border class
	private class borderCanvas  extends Canvas {

	int borderSide=0;

	public borderCanvas(int side) {
		 borderSide=side;

	}

	public void paint(Graphics g) {




	   if (borderType==BORDER_DOUBLE) {

		   if (borderSide==TOP_BORDER) {
		     // upper
			 g.setColor(java.awt.Color.white);
		     g.drawLine(0,0,this.getSize().width,0);
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(3,3,this.getSize().width-4,3);

			 // left border segment
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);
			 // right border segment
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);

		   }

		   // left
		   if (borderSide==LEFT_BORDER) {
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(3,0,3,this.getSize().height);
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);


		   }

		   // right
		   if (borderSide==RIGHT_BORDER) {

			 g.setColor(java.awt.Color.white);
			 g.drawLine(this.getSize().width-4,0,this.getSize().width-4,this.getSize().height);
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);
		   }

		   // bottom
		   if (borderSide==BOTTOM_BORDER) {
			 g.setColor(java.awt.Color.white);
			 g.drawLine(3,0,this.getSize().width-4,0);
		     g.setColor(java.awt.Color.darkGray);
		     g.drawLine(0,this.getSize().height-1,this.getSize().width,this.getSize().height-1);

			 // left border segment
			 g.setColor(java.awt.Color.white);
			 g.drawLine(0,0,0,this.getSize().height);
			 // right border segment
			 g.setColor(java.awt.Color.darkGray);
			 g.drawLine(this.getSize().width-1,0,this.getSize().width-1,this.getSize().height);
		   }
	   }

	    if (borderType==BORDER_SHADOW) {

			if (borderSide==BOTTOM_BORDER) {

  			  g.setColor(pageBackColor);
			  // simulate page backgorund
		      // bottom
		      g.fillRect(0,0,6,4);
			  g.setColor(java.awt.Color.darkGray);
		      // bottom
		      g.fillRect(6,0,this.getSize().width-6,4);

			}

			if (borderSide==RIGHT_BORDER) {

		      // right
		     g=appBorderRight.getGraphics();
		     g.setColor(pageBackColor);
		     g.fillRect(0,0,4,6);
		     g.setColor(java.awt.Color.darkGray);
		      // right
		     g.fillRect(0,6,4,appBorderRight.getSize().height);

			}

		}

		}

	}

}
